//
// ExifData.java
//
// Copyright (C) 1999-2002 Takashi Koike
//
// Last Modified	: 2002/09/08
//
import	java.util.Hashtable;

public class ExifData {
	protected boolean	bIntel;			// oCgь`(Ce`ۂ)
	protected byte[]	buf;			// f[^ǂݍݗpobt@
	protected int		nOffsetTiffHeader;	// obt@TIFFwb_X^[gʒu
	protected int		nCurrentOffset;	// ݂̓ǂݍ݈ʒu
	protected boolean	bCreate;		// createς݂
	protected Hashtable	htInfoIFD0;		// IFD0̏i[e[u
	protected Hashtable	htInfoIFD1;		// IFD1̏i[e[u
	public static int	nDebugLevel;	// fobOp

	final static long	lExifHeader = 0x45786966;	// 'E','x','i','f'
	final static long	lIntelFormat = 0x4949;
	final static long	lMotorolaFormat = 0x4d4d;

	//
	// RXgN^
	//
	ExifData() {
		this.bIntel = true;
		this.nOffsetTiffHeader = this.nCurrentOffset = 0;
		this.bCreate = false;
		ExifData.nDebugLevel = 0;
	}
	ExifData(byte[] buf, int nOffset) {
		this();
		create(buf, nOffset);
	}

	//
	// e탁\bh
	//

	// IuWFNg쐬
	boolean	create(byte[] buf, int nOffset) {
		// Exifwb_[mF
		if (ReadByte.toLong(buf, nOffset, 4, false) != ExifData.lExifHeader) {
			return	false;
		}
		// TIFFwb_[mF
		long lTmp = ReadByte.toLong(buf, nOffset+6, 2, false);
		if (lTmp == ExifData.lIntelFormat) { this.bIntel = true; }
		else if (lTmp == ExifData.lMotorolaFormat) { this.bIntel = false; }
		else { return false; }
		// ok
		this.nCurrentOffset = (int)ReadByte.toLong(buf, nOffset+10, 4, this.bIntel);
		this.buf = buf;
		this.nOffsetTiffHeader = nOffset + 6;
		this.htInfoIFD0 = new Hashtable();
		this.htInfoIFD1 = new Hashtable();
		this.bCreate = true;
		appendTagIFD0(ExifData.tExifOffset);	// ExifOffset̓ǂݍ݂͕K{
		return	true;
	}

	// ^Oǉ(main image, exif sub)
	boolean	appendTagIFD0(int nTagNo) {
		if (!this.bCreate) { return false; }
		this.htInfoIFD0.put(new Integer(nTagNo), new IFDTag());
		return	true;
	}

	// ^Oǉ(thumbnail image)
	boolean	appendTagIFD1(int nTagNo) {
		if (!this.bCreate) { return false; }
		this.htInfoIFD1.put(new Integer(nTagNo), new IFDTag());
		return	true;
	}

	// ^OԍA^O擾(main image, exif sub)
	Object	getIFD0Info(int nTagNo) {
		if (!this.bCreate) { return null; }
		Integer	intTagNo = new Integer(nTagNo);
		return	getIFDData((IFDTag)this.htInfoIFD0.get(intTagNo));
	}

	// ^OԍA^O擾(thumbnail image)
	Object	getIFD1Info(int nTagNo) {
		if (!this.bCreate) { return null; }
		Integer	intTagNo = new Integer(nTagNo);
		return	getIFDData((IFDTag)this.htInfoIFD1.get(intTagNo));
	}

	// ^OA^O擾
	protected Object	getIFDData(IFDTag ifdTag) {
		if (ifdTag == null) { return null; }
		if (ifdTag.getTagNo() == 0) { return null; }
		int	i, nIndex;
		int	nNum = (int)ifdTag.getDataNum();
		int	nDatumLen = (int)ifdTag.getDatumLen();
		int	nDatumUnit = (int)ifdTag.getDatumUnit();
		boolean	bSigned = true;
		switch (ifdTag.getFormat()) {
		case 1: case 3: case 4: case 5:		// 
			bSigned = false;
		case 6: case 8: case 9: case 10:	// 
			if (nNum * nDatumUnit > 1) {
				Long[]	longRet = new Long[nNum*nDatumUnit];
				for (i = 0; i < nNum*nDatumUnit; i++) {
					longRet[i] =  new Long(ReadByte.toLong(this.buf, (this.nOffsetTiffHeader + (int)ifdTag.getDataOffset() + nDatumLen/nDatumUnit * i), nDatumLen/nDatumUnit, this.bIntel, bSigned));
					if (nDebugLevel >= 3) { System.err.println("long value=" + longRet[i]);}
				}
				return	longRet;
			}
			else {
				Long	longRet = new Long(ReadByte.toLong(this.buf, (this.nOffsetTiffHeader + (int)ifdTag.getDataOffset()), nDatumLen, this.bIntel, bSigned));
				if (nDebugLevel >= 3) { System.err.println("long value=" + longRet);}
				return	longRet;
			}
//			break;
		case 2:	// 
			String	strTmp = new String(this.buf, this.nOffsetTiffHeader + (int)ifdTag.getDataOffset(), (int)ifdTag.getDataNum());
			String	strRet;
			nIndex = strTmp.indexOf(0x00);
			if (nIndex < 0) {
				strRet = new String(strTmp);
			}
			else {
				strRet = new String(strTmp.substring(0, nIndex));
			}
			if (nDebugLevel >= 3) { System.err.println("String value=" + strRet);}
			return	strRet;
//			break;
		default:
			return	null;
		}
	}

	// f[^ǂݍ
	boolean	readData() {
		if (!this.bCreate) { return false; }
		// IFD0(main image)ǂ
		readIFD(this.htInfoIFD0);
		// IFD1(thumbnail image)ǂ
		if (this.nCurrentOffset != 0) {
			readIFD(this.htInfoIFD1);
		}
		// Exif SubIFDǂ
		Object	objTmp = getIFD0Info(ExifData.tExifOffset);
		if (objTmp == null) { return false; }
		if (!(objTmp instanceof Long)) { return false; }
		Long	longTmp = (Long)objTmp;
		this.nCurrentOffset = longTmp.intValue();
		readIFD(this.htInfoIFD0);
		return	true;
	}

	// TIFFwb_[̃ItZbgl擾
	int		getOffsetTiffHeader() {
		return	this.nOffsetTiffHeader;
	}

	// IFDf[^ǂݍ (readData() ̃wp[\bh)
	protected boolean	readIFD(Hashtable htInfo) {
		int	i, nNum, nTagNo;
		// fBNgGgǂ
		nNum = (int)ReadByte.toLong(this.buf, this.nOffsetTiffHeader+this.nCurrentOffset, 2, this.bIntel);
		this.nCurrentOffset += 2;
		// fBNgGgǂ
		for (i = 0; i < nNum; i++, this.nCurrentOffset += 12) {
			// ^Oԍ
			nTagNo = (int)ReadByte.toLong(this.buf, this.nOffsetTiffHeader+this.nCurrentOffset, 2, this.bIntel);
			Integer	intTagNo = new Integer(nTagNo);
			// IFDTagIuWFNg擾, 쐬
			IFDTag	ifdTag = (IFDTag)htInfo.get(intTagNo);
			if (ifdTag != null) {
//				ifdTag.nDebugLevel = 3;
				if (!ifdTag.create(this.buf, this.nOffsetTiffHeader, this.nCurrentOffset, this.bIntel)) {
					return	false;
				}
			}
		}
		//  IFD ւ̃ItZbgǂ
		int	nNextOffset = (int)ReadByte.toLong(this.buf, this.nOffsetTiffHeader+this.nCurrentOffset, 4, this.bIntel);
		this.nCurrentOffset = nNextOffset;
		return	true;
	}

	//
	// ^O萔 (IFD0)
	//
	public final static int	tImageWidth			= 0x0100;	// 摜TCY()
	public final static int	tImageLength		= 0x0101;	// 摜TCY()
	public final static int	tBitsPerSample		= 0x0102;	// 񈳏kC[W̏ꍇ́AsNZ̕\(R,G,B)
	public final static int	tCompression		= 0x0103;	// 摜̈k`
	public final static int	tPhotometricInterpretation	= 0x0106;	// 摜̌`
	public final static int	tImageDescription	= 0x010e;	// 摜̐
	public final static int	tMake				= 0x010f;	// J̃[J[
	public final static int	tModel				= 0x0110;	// J̋@햼
	public final static int	tStripOffsets		= 0x0111;	// 񈳏kC[W̏ꍇ́A摜f[^i[ꏊւ̃ItZbg
	public final static int	tOrientation		= 0x0112;	// 摜f[^̋N_
	public final static int	tSamplesPerPixel	= 0x0115;	// 񈳏kC[W̏ꍇ́A1sNZ̃f[^
	public final static int	tRowsPerStrip		= 0x0116;	// 񈳏kC[W𕪊Ċi[Ăꍇ́Aꂼ̕f[^̉C
	public final static int	tStripByteCounts	= 0x0117;	// 񈳏kC[W𕪊Ċi[Ăꍇ́Aꂼ̕f[^̃oCg
	public final static int	tXResolution		= 0x011a;	// 摜\(x)
	public final static int	tYResolution		= 0x011b;	// 摜\(y)
	public final static int	tResolutionUnit		= 0x0128;	// \̒P
	public final static int	tSoftware			= 0x0131;	// t@[EFA̔Ő
	public final static int	tDateTime			= 0x0132;	// 摜̍ŌɕύXꂽ
	public final static int	tJpegIFOffset		= 0x0201;	// JPEG`̏ꍇ́A摜f[^i[ꏊւ̃ItZbg
	public final static int	tJpegIFByteCount	= 0x0202;	// JPEG`̏ꍇ́A摜f[^TCY
	public final static int	tYCbCrCoefficients	= 0x0211;	// 񈳏kC[WYCbCr`Ŋi[Ăꍇ́ARGBϊ萔
	public final static int	tYCbCrSubSampling	= 0x0212;	// F̃TuTvOl
	public final static int	tYCbCrPositioning	= 0x0213;	// F̃Tv|Cg
	public final static int	tReferenceBlackWhite	= 0x0214;	// 摜̍_E_l
	public final static int	tCopyright			= 0x8298;	// 摜̒쌠
	public final static int	tExifOffset			= 0x8769;	// Exif Sub IFDւ̃ItZbg

	//
	// ^O萔 (Exif SubIFD)
	//
	public final static int	tExposureTime		= 0x829a;	// I(s)
	public final static int	tFNumber			= 0x829d;	// YFl
	public final static int	tExposureProgram	= 0x8822;	// I䃂[h
	public final static int	tISOSpeedRatings	= 0x8827;	// CCDx(≖tBZl)
	public final static int	tExifVersion		= 0x9000;	// Exif`̃o[W
	public final static int	tDateTimeOriginal	= 0x9003;	// IWi摜Beꂽ
	public final static int	tDateTimeDigitized	= 0x9004;	// BeɃfW^ꂽ
	public final static int	tComponentConfiguration	= 0x9101;	// 
	public final static int	tCompressedBitsPerPixel	= 0x9102;	// JPEGk
	public final static int	tShutterSpeedValue	= 0x9201;	// Vb^[x(wl)
	public final static int	tApertureValue		= 0x9202;	// Y̍il(wl)
	public final static int	tBrightnessValue	= 0x9203;	// BeEVl
	public final static int	tExposureBiasValue	= 0x9204;	// Be̘I␳(EV)
	public final static int	tMaxApertureValue	= 0x9205;	// Y̊JFl
	public final static int	tSubjectDistance	= 0x9206;	// ʑ̂܂ł̋
	public final static int	tMeteringMode		= 0x9207;	// AȆ[h
	public final static int	tLightSource		= 0x9208;	// (zCgoX)ݒ
	public final static int	tFlash				= 0x9209;	// tbVgp
	public final static int	tFocalLength		= 0x920a;	// Y̏œ_
	public final static int	tMakerNote			= 0x927c;	// [J[ˑf[^
	public final static int	tUserComment		= 0x9286;	// [U[Rg
	public final static int	tFlashPixVersion	= 0xa000;	// tbVsbNX̃o[W
	public final static int	tColorSpace			= 0xa001;	//
	public final static int	tExifImageWidth		= 0xa002;	// C摜̑傫()
	public final static int	tExifImageHeight	= 0xa003;	// C摜̑傫()
	public final static int	tRelatedSoundFile	= 0xa004;	// 摜ƈꏏɘ^ł@ł́At@C̖O
	public final static int	tExifInteroperabilityOffset	= 0xa005;	// gp
	public final static int	tFocalPlaneXResolution	= 0xa20e;	// CCD̉fx
	public final static int	tFocalPlaneYResolution	= 0xa20f;	// CCD̉fx
	public final static int	tFocalPlaneResolutionUnit	= 0xa210;	// CCD̉fx̒P
	public final static int	tSensingMethod		= 0xa217;	// C[WZT[̌`
	public final static int	tFileSource			= 0xa300;	//
	public final static int	tSceneType			= 0xa301;	//
	public final static int	tFocalLengthIn35mmFilm	= 0xa405;	// 35mmZœ_
}
