//
// ImageProperty.java
//
// Copyright (C) 1999-2006 Takashi Koike
//
// Last Modified	: 2006/11/26
//
import	java.text.*;
import	java.util.*;

public class ImageProperty {
	protected String	strErrorMsg;	// G[bZ[W

	// evpeB
	protected int		nCompression;			// k
	protected byte[]	byThumbImage;			// TlC摜f[^
	protected String	strFilename;			// t@C
	protected String	strModel;				// @햼
	protected String	strDateTimeOriginal;	// Be
	protected int		nImageWidth, nImageHeight;	// 摜TCY
	protected int		nFocalLength;			// œ_
	protected String	strApertureValue;		// il
	protected String	strExposureTime;		// Vb^[Xs[h
	protected int		nISOSpeedRatings;		// ISOx
	protected String	strExposureProgram;		// IovO
	protected String	strMeteringMode;		// [h
	protected String	strExposureBiasValue;	// Io␳
	protected String	strFlash;				// tbV"ON"or""

	public static int	nDebugLevel;			// fobOp

	//
	// RXgN^
	//
	ImageProperty(String strJpegFilename) {
		this.byThumbImage = null;
		this.strFilename = strJpegFilename;
		this.strModel = this.strDateTimeOriginal = this.strApertureValue = this.strExposureTime = this.strExposureProgram
			= this.strMeteringMode = this.strExposureBiasValue = this.strFlash = "";
		this.nImageWidth = this.nImageHeight
			= this.nFocalLength = this.nISOSpeedRatings = 0;
		ImageProperty.nDebugLevel = 0;
	}
	ImageProperty(String strJpegFilename, byte[] byBuf, int nOffset) {
		this(strJpegFilename);
		setParam(byBuf, nOffset);
	}
	ImageProperty(String strJpegFilename, byte[] byApp1Data) {
		this(strJpegFilename, byApp1Data, 0);
	}

	//
	// e탁\bh
	//

	// IuWFNg쐬
	boolean	setParam(byte[] byBuf, int nOffset) {
		// exif p[T[쐬
		ExifData	exifData = new ExifData();
		if (!exifData.create(byBuf, nOffset)) {
			this.strErrorMsg = "Internal error. [Could not create ExifData object]";
			return false;
		}
		// ^Oݒ
		int	j;
		for (j = 0; j < ImageProperty.nSearchTagsIFD0.length; j++) {
			if (!exifData.appendTagIFD0(ImageProperty.nSearchTagsIFD0[j])) {
				this.strErrorMsg = "Internal error. [Could not append search tag(s)]";
				return false;
			}
		}
		for (j = 0; j < ImageProperty.nSearchTagsIFD1.length; j++) {
			if (!exifData.appendTagIFD1(ImageProperty.nSearchTagsIFD1[j])) {
				this.strErrorMsg = "Internal error. [Could not append search tag(s)]";
				return false;
			}
		}
		// f[^
		if (!exifData.readData()) {
			this.strErrorMsg = "Internal error. [Could not read exif data]";
			return false;
		}
		// evpeBݒ
		if (!setThumbnailInfo(exifData)) { return false; }
		if (!setThumbnailImage(exifData, byBuf, nOffset)) { return false; }
		return	true;
	}

	// CSV`̃f[^o(^O)
	static String	getCSVTagString() {
		return	new String("\"Filename\",\"Model\",\"Date Time\",\"Width\",\"Height\","
				+ "\"FocalLength\",\"ApertureValue\",\"ExposureTime[sec.]\","
				+ "\"ISOSpeedRatings\","
				+ "\"ExposureProgram\",\"MeteringMode\",\"ExposureBiasValue[EV]\","
				+ "\"Flash\"");
	}

	// CSV`̃f[^o
	String	getCSVString() {
		return	new String("\"" + this.strFilename + "\",\"" + this.strModel + "\","
				+ "\"" + this.strDateTimeOriginal + "\",\"" + this.nImageWidth + "\",\"" + this.nImageHeight + "\","
				+ "\"" + this.nFocalLength + "\",\"" + this.strApertureValue + "\",\"" + this.strExposureTime + "\","
				+ "\"" + this.nISOSpeedRatings + "\","
				+ "\"" + this.strExposureProgram + "\",\"" + this.strMeteringMode + "\",\"" + this.strExposureBiasValue + "\","
				+ "\"" + this.strFlash + "\"");
	}

	int	getCompression() { return this.nCompression; }					// k
	byte[]	getThumbImage() { return this.byThumbImage; }				// TlC摜f[^
	String	getFilename() { return this.strFilename; }					// t@C
	String	getModel() { return this.strModel; }						// @햼
	String	getDateTimeOriginal() { return this.strDateTimeOriginal; }	// Be
	int	getImageWidth() { return this.nImageWidth; }					// 摜TCY
	int	getImageHeight() { return this.nImageHeight; }					// 摜TCY
	int	getFocalLength() { return this.nFocalLength; }					// œ_
	String	getApertureValue() { return this.strApertureValue; }		// il
	String	getExposureTime() { return this.strExposureTime; }			// Vb^[Xs[h
	int	getISOSpeedRatings() { return this.nISOSpeedRatings; }			// ISOx
	String	getExposureProgram() { return this.strExposureProgram; }	// IovO
	String	getMeteringMode() { return this.strMeteringMode; }			// [h
	String	getExposureBiasValue() { return this.strExposureBiasValue; }// Io␳
	String	getFlash() { return this.strFlash; }						// tbV"On"or""

	// TlC摜̍쐬(setParam()̃wp[\bh)
	protected boolean	setThumbnailImage(ExifData exifData, byte[] byBuf, int nOffset) {
		Object	objTmp;
		objTmp = exifData.getIFD1Info(ExifData.tCompression);
		if (objTmp == null || !(objTmp instanceof Long)) {
			this.strErrorMsg = "Invalid data. [Compression method]";
			return false;
		}
		this.nCompression = ((Long)objTmp).intValue();	// k
		if (this.nCompression == 6) {
			// thumbnail f[^ JPEG `
			long	lJpegIFOffset, lJpegIFByteCount;
			// JPEG摜 thumbnail f[^i[ʒuǂݍ
			objTmp = exifData.getIFD1Info(ExifData.tJpegIFOffset);
			if (objTmp == null || !(objTmp instanceof Long)) {
				this.strErrorMsg = "Invalid data. [JpegIFOffset]";
				return false;
			}
			lJpegIFOffset = ((Long)objTmp).longValue() + nOffset + exifData.getOffsetTiffHeader();
			// JPEG摜 thumbnail f[^TCYǂݍ
			objTmp = exifData.getIFD1Info(ExifData.tJpegIFByteCount);
			if (objTmp == null || !(objTmp instanceof Long)) {
				this.strErrorMsg = "Invalid data. [JpegIFByteCount]";
				return false;
			}
			lJpegIFByteCount = ((Long)objTmp).longValue();
			// JPEG摜 thumbnail f[^
			if (lJpegIFOffset + lJpegIFByteCount > byBuf.length) {
				lJpegIFByteCount = byBuf.length - lJpegIFOffset;
			}
			this.byThumbImage = new byte[(int)lJpegIFByteCount];
			int	i;
			for (i = 0; i < lJpegIFByteCount; i++) {
				this.byThumbImage[i] = byBuf[(int)lJpegIFOffset + i];
			}
		}
		return	true;
	}

	// TlC̍쐬(setParam()̃wp[\bh)
	protected boolean	setThumbnailInfo(ExifData exifData) {
		this.strErrorMsg = "Invalid data. [image information]";
		Object	objTmp, objTmp1;
		int	i;
		// @햼
		objTmp = exifData.getIFD0Info(ExifData.tModel);
		if (objTmp != null) {
			if (!(objTmp instanceof String)) { return false; }
			this.strModel = (String)objTmp;
		}
		// 摜TCY
		objTmp	= exifData.getIFD0Info(ExifData.tExifImageWidth);
		objTmp1	= exifData.getIFD0Info(ExifData.tExifImageHeight);
		if (objTmp != null && objTmp1 != null) {
			if (!(objTmp instanceof Long) || !(objTmp1 instanceof Long)) { return false; }
			this.nImageWidth = ((Long)objTmp).intValue();
			this.nImageHeight = ((Long)objTmp1).intValue();
		}
		// 
		objTmp = exifData.getIFD0Info(ExifData.tDateTimeOriginal);
		if (objTmp != null) {
			if (!(objTmp instanceof String)) { return false; }
			this.strDateTimeOriginal = ((String)objTmp);
			// "YYYY:MM:DD HH:MM:SS"̃tH[}bgŊi[Ă
			try {	// 0.46 t̓Ȃ@̏ꍇANumberFormatExceptionN̂ő΍
				int year   = Integer.valueOf(this.strDateTimeOriginal.substring(0, 4)).intValue();
				int month  = Integer.valueOf(this.strDateTimeOriginal.substring(5, 7)).intValue();
				int day    = Integer.valueOf(this.strDateTimeOriginal.substring(8, 10)).intValue();
				int hour   = Integer.valueOf(this.strDateTimeOriginal.substring(11, 13)).intValue();
				int minute = Integer.valueOf(this.strDateTimeOriginal.substring(14, 16)).intValue();
				int second = Integer.valueOf(this.strDateTimeOriginal.substring(17, 19)).intValue();
				if (year > 0 || month > 0 || day > 0) {
					// tݒ肳Ă΁ALocaleɏtH[}bgŐݒ肵
					Calendar datetime = Calendar.getInstance();
					datetime.set(year, month - 1, day, hour, minute, second);	// 0.45ł̃oOC, month0N_(1)
					this.strDateTimeOriginal = DateFormat.getDateTimeInstance(DateFormat.MEDIUM, DateFormat.MEDIUM).format(datetime.getTime());
				}
			}
			catch (NumberFormatException e) {
				if (nDebugLevel >= 3) { System.err.println(e); }
			}
		}
		// œ_
		double	fIndex, fValue;
		objTmp	= exifData.getIFD0Info(ExifData.tFocalLengthIn35mmFilm);
		objTmp1	= exifData.getIFD0Info(ExifData.tFocalLength);
		if (objTmp != null) {
			if (!(objTmp instanceof Long)) { return false; }
			this.nFocalLength = ((Long)objTmp).intValue();
		}
		else if (objTmp1 != null) {
			fIndex = getRationalValue(exifData, ExifData.tFocalLength);
			fValue = Math.round(10.0 * fIndex) / 10.0;
			this.nFocalLength = (int)fValue;
		}
		// il
		objTmp = exifData.getIFD0Info(ExifData.tFNumber);
		objTmp1 = exifData.getIFD0Info(ExifData.tApertureValue);
		if (objTmp != null || objTmp1 != null) {
			if (objTmp != null) {
				fIndex = getRationalValue(exifData, ExifData.tFNumber);
				fValue = Math.round(10.0 * fIndex) / 10.0;
			}
			else {
				fIndex = getRationalValue(exifData, ExifData.tApertureValue);
				fValue = Math.round(10.0 * Math.pow(Math.sqrt(2.0), fIndex)) / 10.0;
			}
			this.strApertureValue = "" + fValue;
		}
		// Vb^[Xs[h
		objTmp = exifData.getIFD0Info(ExifData.tExposureTime);
		objTmp1 = exifData.getIFD0Info(ExifData.tShutterSpeedValue);
		if (objTmp != null || objTmp1 != null) {
			if (objTmp != null) {
				fValue = 1.0 / getRationalValue(exifData, ExifData.tExposureTime);
			}
			else {
				fIndex = getRationalValue(exifData, ExifData.tShutterSpeedValue);
				fValue = Math.pow(2.0, fIndex);
			}
			if (Math.round(fValue) > 1.0) {
				Long	longTmp = new Long(Math.round(fValue));
				this.strExposureTime = "1/" + longTmp.toString();
			}
			else {
				Long	longTmp = new Long(Math.round(1.0 / fValue));
				this.strExposureTime = longTmp.toString();
			}
		}
		// ISOx
		objTmp	= exifData.getIFD0Info(ExifData.tISOSpeedRatings);
		if (objTmp != null) {
			if (!(objTmp instanceof Long)) { return false; }
			this.nISOSpeedRatings = ((Long)objTmp).intValue();
		}
		// IovO
		objTmp = exifData.getIFD0Info(ExifData.tExposureProgram);
		if (objTmp != null) {
			if (!(objTmp instanceof Long)) { return false; }
			int	nIndex = ((Long)objTmp).intValue();
			this.strExposureProgram = (nIndex < ImageProperty.strExposureProgramArray.length) ? ImageProperty.strExposureProgramArray[nIndex] : "Reserved exposure";
		}
		// [h
		objTmp = exifData.getIFD0Info(ExifData.tMeteringMode);
		if (objTmp != null) {
			if (!(objTmp instanceof Long)) { return false; }
			int	nIndex = ((Long)objTmp).intValue();
			this.strMeteringMode = (nIndex < ImageProperty.strMeteringModeArray.length) ? ImageProperty.strMeteringModeArray[((Long)objTmp).intValue()] : "Reserved or Other metering";
		}
		// Io␳
		fIndex = getRationalValue(exifData, ExifData.tExposureBiasValue);
		if (fIndex != 0.0) {
			Double	doubleTmp = new Double(Math.round(100.0 * fIndex) / 100.0);
			this.strExposureBiasValue = ((fIndex > 0) ? "+" : "") + doubleTmp.toString();
		}
		// tbV
		objTmp = exifData.getIFD0Info(ExifData.tFlash);
		if (objTmp != null) {
			if (!(objTmp instanceof Long)) { return false; }
			int	nFlash = ((Long)objTmp).intValue();
			if ((nFlash & 0x01) != 0) {
				this.strFlash = "On";
			}
		}
		return	true;
	}

	// ̒l擾 (setThumbnailInfo()̃wp[\bh)
	protected double getRationalValue(ExifData exifData, int nTagNo) {
		Object	objTmp;
		objTmp = exifData.getIFD0Info(nTagNo);
		if (objTmp == null) { return 0.0; }
		if (!(objTmp instanceof Long[])) { return 0.0; }
		Long[]	longRational = (Long [])objTmp;
		if (nDebugLevel >= 3) { System.err.println(longRational[0].toString() + "/" + longRational[1].toString()); }
		return	longRational[0].doubleValue() / longRational[1].doubleValue();
	}

	final static int[]	nSearchTagsIFD0	= {		// Exif IFD0肵̃^O
//		ExifData.tMake,
		ExifData.tModel,
		ExifData.tDateTimeOriginal, ExifData.tExifImageWidth, ExifData.tExifImageHeight,
		ExifData.tFNumber, ExifData.tApertureValue, ExifData.tFocalLength, ExifData.tFocalLengthIn35mmFilm,
		ExifData.tExposureTime, ExifData.tShutterSpeedValue,
		ExifData.tISOSpeedRatings,
		ExifData.tExposureProgram,ExifData.tMeteringMode, ExifData.tExposureBiasValue,
		ExifData.tFlash
	};
	final static int[]	nSearchTagsIFD1	= {		// Exif IFD1肵̃^O
		ExifData.tCompression, ExifData.tJpegIFOffset, ExifData.tJpegIFByteCount,
		ExifData.tStripOffsets, ExifData.tStripByteCounts
	};
	final static String[]	strExposureProgramArray = {
		"Unknown exposure", "Manual exposure", "Program AE", "Aperture priority AE",
		"Shutter priority AE", "Creative program AE", "Action program AE",
		"Portrait mode AE", "Landscape mode AE"
	};
	final static String[]	strMeteringModeArray = {
		"Unknown metering", "Average metering", "CenterWeightedAverage metering", "Spot metering",
		"MultiSpot metering", "Pattern metering", "Partial metering"
	};
}
