//
// ReadByte.java
//
// Copyright (C) 1999-2003 Takashi Koike
//
// Last Modified	: 2003/07/20
//
public class ReadByte {
	public static long toLong(byte[] buf) {
		return	toLong(buf, true, true);
	}
	public static long toLong(byte[] buf, boolean bIntel, boolean bSigned) {
		return	toLong(buf, 0, buf.length, bIntel, bSigned);
	}
	public static long toLong(byte[] buf, int nOffset, int nLength, boolean bIntel) {
		return	toLong(buf, nOffset, nLength, bIntel, false);
	}
	public static long toLong(byte[] buf, int nOffset, int nLength, boolean bIntel, boolean bSigned) {
		long	lValue = 0;
		int		i;
		byte	byMSB = (bIntel) ? buf[nOffset+nLength-1] : buf[nOffset];
		if (bSigned && (byMSB & 0x80) != 0) {
			lValue = -1;
		}
		for (i = 0; i < nLength; i++) {
			long	lTmp = buf[nOffset + ((bIntel) ? (nLength - i - 1) : i)];
			if (lTmp < 0) { lTmp += 256; }
			lValue = lValue << 8 | lTmp;
		}
		return	lValue;
	}
}
